<!DOCTYPE html>
<html>
<head>
    <title>Explore API</title>
    <style>
option.default {
    font-style: oblique;
}

option:not(.default) {
    font-family: monospace;
}

.api_url
{
    font-family: monospace;
    font-size: larger;
}
a.api_url:active, a.api_url:visited, a.api_url:link {
    color: black;
    text-decoration: none;
    border-bottom: 1px dotted black;
}
a.api_url:hover {
    color: black;
    border-bottom: 1px solid black;
}

#preview_url {
    border: 1px solid gray;
    border-radius: 8px 8px 0 0;
    display: inline-block;
    font-family: monospace;
    margin: 2ex 2ex 0;
    padding: 1em;
    white-space: pre-wrap;
    border-bottom: 0;
}

#preview_response {
    border: 1px solid gray;
    font-family: monospace;
    margin: 0 2ex 2ex;
    padding: 1em;
    white-space: pre-wrap;
}
    </style>
</head>
<body>
<form method="post">
<table>
<h1>Explore API</h1>
<p>View the <a href="{% url 'insult:help' %}">API Help</a>.</p>
<tbody>
    <tr>
        <th><label for="lang">Language</label></th>
        <td>
            <select name="lang" id="lang">
                <option value="" class="default">Default</option>
                {% for lang in languages %}
                    <option value="{{ lang }}">{{ lang }}</option>
                {% endfor %}
            </select>
        </td>
    </tr>
    <tr>
        <th><label for="format">Format</label></th>
        <td>
            <select name="format" id="format">
                {% for format in formats %}
                    <option value="{{ format.name }}">{{ format.name }}</option>
                {% endfor %}
            </select>
        </td>
    </tr>
    <tr>
        <th><label for="template">Template</label></th>
        <td>
            <textarea id="template" name="template" rows="10" cols="40"></textarea>
        </td>
    </tr>
    <tr>
        <th><label for="who">Who</label></th>
        <td>
            <input type="text" id="who" name="who" />
        </td>
    </tr>
    <tr>
        <th><label for="plural">Plural</label></th>
        <td>
            <input type="checkbox" id="plural" name="plural" />
        </td>
    </tr>
</tbody>
</table>
<input type="submit" value="View" />

<script>

var preview = null;
var preview_url = null;
var preview_response = null;

function create_preview_div()
{
    if ( preview )
        return;

    preview = document.createElement("div");

    var preview_title = document.createElement("h2")
    preview_title.appendChild(document.createTextNode("Preview"));
    preview.appendChild(preview_title);

    preview_url = document.createElement("div");
    preview_url.id = "preview_url";
    preview.appendChild(preview_url);

    preview_response = document.createElement("div");
    preview_response.id = "preview_response";
    preview.appendChild(preview_response);

    document.body.appendChild(preview);
}


function form_submit(ev)
{
    var request = new XMLHttpRequest();
    request.onload = function()
    {
        create_preview_div();
        var url = request.getResponseHeader("X-Insult-Url");
        var link = document.createElement("a");
        link.className = "api_url";
        link.appendChild(document.createTextNode(url));
        link.setAttribute("href", url);
        if (preview_url.firstChild)
        {
            preview_url.removeChild(preview_url.firstChild);
        }
        preview_url.appendChild(link);

        if (request.status == 200)
        {
            preview_response.innerText = request.responseText;
        }
    };

    request.open("POST", "", true);
    var form_data = new FormData(document.getElementsByTagName("form")[0]);
    request.send(form_data);

    ev.preventDefault();
}

var form = document.forms[0];
form.addEventListener('submit', form_submit, false);
</script>
</form>
</body>
